﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;

public partial class ipin_process : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        // 인증 결과 데이터를 암호화한 데이터입니다. 
        // ipin_main 페이지에서 생성된 암호화 데이터와는 다릅니다.
        string sResponseData = Request["enc_data"];

        // 암호화된 사용자 정보가 존재하는 경우
        if (!sResponseData.Equals("") && sResponseData != null)
        {

            // 인증결과 데이터를 최종 수신하는 귀사의 결과 페이지 URL 
            FormWriter fw = new FormWriter("ipin_result.aspx");

            fw.Add("enc_data", sResponseData);

            string strHtml = fw.MakeForm();
            if (strHtml.Length > 0)
            {
                Response.Clear();
                Response.Write(strHtml);
                Response.End();
            }
        }
    }

    public class FormWriter
    {
        private string mSubmitURL;
        private string mMethod;
        private Hashtable mHash = new Hashtable();

        public FormWriter()
        {
        }

        public FormWriter(string rurl)
        {
            mSubmitURL = rurl;
        }

        // rurl : 팝업 URL, method - POST, GET
        public FormWriter(string rurl, string method)
        {
            mSubmitURL = rurl;
            mMethod = method;
        }

        // 프로퍼티 이동할 페이지 URL
        public string SubmitURL
        {
            get { return mSubmitURL; }
            set { mSubmitURL = value; }
        }

        // post로 전송할값 추가
        public void Add(string key, string value)
        {
            mHash.Add(key, value);
        }

        public void Clear()
        {
            mHash.Clear();
        }

        public void Remove(string key)
        {
            mHash.Remove(key);
        }

        public int Count
        {
            get { return mHash.Count; }
        }

        // HTML을 생성하여 string 값으로 리턴
        public string MakeForm()
        {
            string strForm = null;

            if (mSubmitURL == null)
            {
                return null;
            }

            if (mMethod == null)
            {
                mMethod = "POST";
            }

            strForm = "<html> \n<head> \n<title></title> \n" +
                      "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=euc-kr\"> \n" +
                      "<script> \n" +
                      "function fnLoad(){ \n";

            // GET 또는 POST 로 전송할 키와 값을 생성
            foreach (DictionaryEntry de in mHash)
            {
                strForm += "parent.opener.parent.document.vnoform." + (string)de.Key + ".value = \"" + (string)de.Value + "\"; \n";
            }

            //  당사에서는 최상위를 'parent.opener.parent.document.'로 정의하였습니다
            //  귀사의 환경 및 프로세스에 맞게 정의하시기 바랍니다
            strForm += "parent.opener.parent.document.vnoform.target = \"Parent_window\"; \n" +
                       "parent.opener.parent.document.vnoform.action = \"" + mSubmitURL + "\"; \n" +
                       "parent.opener.parent.document.vnoform.submit(); \n" +
                       "self.close(); \n" +
                       "} \n" +
                       "</script> \n" +
                       "</head> \n" +
                       "<body onLoad=\"fnLoad();\"> \n" +
                       "</body> \n</html>";

            return strForm;
        }
    }
}
